function p = AUSWSPLINE(x,f,s,t0,tn,delta)
% p = AUSWSPLINE(x,f,s,t0,tn,delta)
%
% Interpolation mittels kubischer Splines und natrlicher Randbedingung bei
% gegebenen Sttzstellen x, Funktionswerten f und Ableitungen s gleicher Lnge
% sowie dem zu untersuchenden Intervall [t0,tn] mit Gitterabstand delta
%
% Das Ergebnis wird in p abgelegt
%
% -----------------------------------------------------------------------------
%
% Eingabe
% -------
% x         Sttzstellenvektor
% f         Funktionswerte
% s         Vektor der Ableitungen
% t0        linker Intervallrand  \   Der Spline soll an den Stellen 
% tn        rechter Intervallrand |   t0, t0+delta, t0+2*delta,..., tn 
% delta     Gitterweite           /   sukzessive ausgewertet werden.
%                                     
% -----------------------------------------------------------------------------
% 
% Ausgabe
% -------
% p         Wert des Splines an den Stellen t0:delta:tn

