addpath('../routines/');
addpath('../examples/');

strgbsp{1}='1/(1+25t^2)';
strgbsp{2}='sqrt(|t|)';
strgbsp{3}='Fahrbahndaten';
strgbsp{4}='ENDE';

strgalg{1}='Spline-Interpolation';
strgalg{2}='Polynom-Interpolation';
strgalg{3}='Vergleich beider';
strgalg{4}='ENDE';

strgst{1}='quidistante Sttzstellen';
strgst{2}='Tschebyscheff-Sttzstellen';
strgst{3}='ENDE';


% Anzahl Testmatrizen pro Dimension

method=0;
method=menu('Welches Verfahren?',strgalg);
if method==4
   return
end
fprintf('%s\n',strgalg{method})
while method<4

      bsp=0;
      bsp=menu('Welches Beispiel?',strgbsp);
      if bsp==4
	 return
      end
      fprintf('%s\n',strgbsp{bsp})

      if bsp<3
	 st=0;
	 st=menu('Welche Sttzstellen?',strgst);
	 if st==3
	    return
	 end
	 fprintf('%s\n',strgst{st})
	 v=2:2:10;
      else
	 v=[5 10 50];
      end

      clear legendtxt1 legendtxt2
      i=1;
      if bsp<3
	 legendtxt1{i}='Funktion';
      else
	 legendtxt1{i}='Daten';
      end
      i=i+1;
      if method==1 | method==3
	 legendtxt1{i}='Spline';
	 i=i+1;
      end 
      if method==2 | method==3
	 legendtxt1{i}='Polynom';
      end 

      j=1;
      if method==1 | method==3
	 legendtxt2{j}='Spline';
	 j=j+1;
      end 
      if method==2 | method==3
	 legendtxt2{j}='Polynom';
      end 
      
      fl=zeros(2,length(v));
      fehler=zeros(2,length(v));

      j=1;
      figure(1); 
      clf
      for n=v
	  if bsp<=2
	     if st==1
		h=2/n;
		t=-1:h:1;
	     else
		t=fliplr(cos((2*(0:n)+1)*(pi/(2*n+2))));
	     end
	     delta=0.002;
	     t0=-1;
	     tn=1;
	     tt=t0:delta:tn;
	  else   
	     load '../examples/fahrbahn.dat'
	     m=(size(fahrbahn,1)-1)/n;
	     t=fahrbahn(1:m:end,1)';
	     delta=0.1;
	     t0=fahrbahn(1,1);
	     tn=fahrbahn(end,1);
	     tt=t0:delta:tn;
	  end
	  
	  if bsp==1
	     f =1./(1+25*t.*t);
	     ff=1./(1+25*tt.*tt);
	     Dfn=-50/(1+25)^2;
	     Df0=-Dfn;
	  elseif bsp==2
	     f=sqrt(abs(t));
	     ff=sqrt(abs(tt));
	     Dfn=1/2;
	     Df0=-Dfn;
	  else
	     f=fahrbahn(1:m:end,2);
	  end
	    
	  if method==1 | method==3
	     tstart = clock;
	     % Spline--Interpolation
	     if bsp<=2
		s=VSPLINE(t,f,Df0,Dfn);
	     else
		s=NSPLINE(t,f);
	     end % for i
	     pp1=AUSWSPLINE(t,f,s,t0,tn,delta);
	     fl(1,j)=fl(1,j)+etime(clock,tstart); 
	  end
	  if method==2 | method==3
	     tstart = clock;
	     dd=DIVDIFF(t,f);
	     pp2=AUSW(t,dd,tt);
	     fl(2,j)=fl(2,j)+etime(clock,tstart); 
	  end

	  figure(j+1)
	  clf
	  if bsp<3
	     plot(tt,ff,'-g')
	     hold on
	     if method==1 | method==3
		plot(tt,pp1,':r')
	     end 
	     if method==2 | method==3
		plot(tt,pp2,'--m')
	     end 
	     plot(t,f,'+b')
	     hold off
	  else
	     plot(fahrbahn(:,1),fahrbahn(:,2),'+g')
	     hold on
	     if method==1 | method==3
		plot(tt,pp1,':r')
	     end 
	     if method==2 | method==3
		plot(tt,pp2,'--m')
	     end 
	     plot(t,f,'ob')
	     hold off
	     axis([fahrbahn([1 end],1)' -1 2])
	  end % if
	  xlabel('t')
	  ylabel('y')
	  title(['Interpolation, n=' num2str(n)])
	  legend(legendtxt1)
	  pause(0.01)
	  
	  figure(1)
	  if method==1 | method==3
	     semilogy(n,fl(1,j),'+b')
	     hold on
	  end % if 
	  if method==2 | method==3
	     semilogy(n,fl(2,j),'om')
	     hold on
	  end % if
	  xlabel('n')
	  ylabel('Zeit [sec]')
	  title('Rechenzeit')
	  legend(legendtxt2)
	  pause(0.01)
	  
	  j=j+1;
      end % for n

      method=menu('Welches Verfahren?',strgalg);
      if method==4
	 return
      end
      fprintf('%s\n',strgalg{method})

end % while

